stages:
  - build

before_script:
  - buildah login -u $DOCKER_HUB_USER -p $DOCKER_HUB_PASSWORD docker.io

build_buildah:
  extends:
    - .build
  stage: build
  variables:
    IMAGE_NAME: buildah
    TAG: buildah
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - buildah/*
        - .gitlab-ci.yml

build_node14-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    NODE_VERSION: 14
    IMAGE_NAME: node-dind
    TAG: node14-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-dind/*
        - node-python-dind/*
        - node-python-compose-dind/*
        - .gitlab-ci.yml

build_node16-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    NODE_VERSION: 16
    IMAGE_NAME: node-dind
    TAG: node16-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-dind/*
        - node-python-dind/*
        - node-python-compose-dind/*
        - .gitlab-ci.yml

build_node18-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    NODE_VERSION: 18
    IMAGE_NAME: node-dind
    TAG: node18-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-dind/*
        - node-python-dind/*
        - node-python-compose-dind/*
        - .gitlab-ci.yml

build_node16-buildah:
  extends:
    - .build
  stage: build
  variables:
    NODE_VERSION: 16.17.0
    IMAGE_NAME: node-buildah
    TAG: node16-buildah
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-buildah/*
        - .gitlab-ci.yml

build_node18-buildah:
  extends:
    - .build
  stage: build
  variables:
    NODE_VERSION: 18.17.0
    IMAGE_NAME: node-buildah
    TAG: node18-buildah
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-buildah/*
        - .gitlab-ci.yml

build_node20-buildah:
  extends:
    - .build
  stage: build
  variables:
    NODE_VERSION: 20.12.2
    IMAGE_NAME: node-buildah
    TAG: node20-buildah
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-buildah/*
        - .gitlab-ci.yml

build_node22-buildah:
  extends:
    - .build
  stage: build
  variables:
    NODE_VERSION: 22.0.0
    IMAGE_NAME: node-buildah
    TAG: node22-buildah
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-buildah/*
        - .gitlab-ci.yml

build_node14_python3:
  extends:
    - .build
  stage: build
  needs:
    - build_node14-dind
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    NODE_VERSION: 14
    IMAGE_NAME: node-python-dind
    TAG: node14-python3-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-python-dind/*
        - .gitlab-ci.yml

build_node16_python3:
  extends:
    - .build
  stage: build
  needs:
    - build_node16-dind
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    NODE_VERSION: 16
    IMAGE_NAME: node-python-dind
    TAG: node16-python3-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-python-dind/*
        - .gitlab-ci.yml

build_node16_python3_compose-dind:
  extends:
    - .build
  stage: build
  needs:
    - build_node16-dind
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    NODE_VERSION: 16
    IMAGE_NAME: node-python-compose-dind
    TAG: node16-python3-compose-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - node-python-compose-dind/*
        - .gitlab-ci.yml

build_azure-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    IMAGE_NAME: azure-dind
    TAG: azure-dind20
  needs:
    - build_python-dind
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - python-dind/*
        - python-compose-dind/*
        - azure-dind/*
        - .gitlab-ci.yml

build_python-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    IMAGE_NAME: python-dind
    TAG: python3-dind20
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - python-dind/*
        - python-compose-dind/*
        - azure-dind/*
        - .gitlab-ci.yml

build_python_compose-dind:
  extends:
    - .build
  stage: build
  variables:
    DOCKER_VERSION: 20
    PYTHON_VERSION: 3
    IMAGE_NAME: python-compose-dind
    TAG: python3-compose-dind20
  needs:
    - build_python-dind
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - when: always
      changes:
        - python-compose-dind/*
        - .gitlab-ci.yml

.build:
  image: quay.io/buildah/stable
  script:
    - buildah build --platform linux/amd64 --build-arg NODE_VERSION=${NODE_VERSION} --build-arg PYTHON_VERSION=${PYTHON_VERSION} --build-arg DOCKER_VERSION=${DOCKER_VERSION} --tag "docker.io/eyecatch/oci-builder:${TAG}" -f ./$IMAGE_NAME/Dockerfile .
    - buildah push docker.io/eyecatch/oci-builder:${TAG}
